#include "betray.h"
#include "forge.h"

typedef struct{
	char *name;
	uint system_code;
}BButton;

extern BButton *betray_buttons;

typedef enum{
	BETRAY_ENUM_BUTTON_CANCEL,
	BETRAY_ENUM_BUTTON_BACK,
	BETRAY_ENUM_BUTTON_TAB,
	BETRAY_ENUM_BUTTON_CLEAR,
	BETRAY_ENUM_BUTTON_RETURN,
	BETRAY_ENUM_BUTTON_SHIFT,
	BETRAY_ENUM_BUTTON_CONTROL,
	BETRAY_ENUM_BUTTON_MENU,
	BETRAY_ENUM_BUTTON_PAUSE,
	BETRAY_ENUM_BUTTON_CAPS_LOCK,
	BETRAY_ENUM_BUTTON_ESCAPE,
	BETRAY_ENUM_BUTTON_SPACE,
	BETRAY_ENUM_BUTTON_PREV,
	BETRAY_ENUM_BUTTON_NEXT,
	BETRAY_ENUM_BUTTON_END,
	BETRAY_ENUM_BUTTON_HOME,
	BETRAY_ENUM_BUTTON_LEFT,
	BETRAY_ENUM_BUTTON_UP,
	BETRAY_ENUM_BUTTON_RIGHT,
	BETRAY_ENUM_BUTTON_DOWN,
	BETRAY_ENUM_BUTTON_SELECT,
	BETRAY_ENUM_BUTTON_PRINT,
	BETRAY_ENUM_BUTTON_EXECUTE,
	BETRAY_ENUM_BUTTON_SCREENSHOT,
	BETRAY_ENUM_BUTTON_INSERT,
	BETRAY_ENUM_BUTTON_DELETE,
	BETRAY_ENUM_BUTTON_BACKSPACE,
	BETRAY_ENUM_BUTTON_HELP,
	BETRAY_ENUM_BUTTON_0,
	BETRAY_ENUM_BUTTON_1,
	BETRAY_ENUM_BUTTON_2,
	BETRAY_ENUM_BUTTON_3,
	BETRAY_ENUM_BUTTON_4,
	BETRAY_ENUM_BUTTON_5,
	BETRAY_ENUM_BUTTON_6,
	BETRAY_ENUM_BUTTON_7,
	BETRAY_ENUM_BUTTON_8,
	BETRAY_ENUM_BUTTON_9,
	BETRAY_ENUM_BUTTON_A,
	BETRAY_ENUM_BUTTON_B,
	BETRAY_ENUM_BUTTON_C,
	BETRAY_ENUM_BUTTON_D,
	BETRAY_ENUM_BUTTON_E,
	BETRAY_ENUM_BUTTON_F,
	BETRAY_ENUM_BUTTON_G,
	BETRAY_ENUM_BUTTON_H,
	BETRAY_ENUM_BUTTON_I,
	BETRAY_ENUM_BUTTON_J,
	BETRAY_ENUM_BUTTON_K,
	BETRAY_ENUM_BUTTON_L,
	BETRAY_ENUM_BUTTON_M,
	BETRAY_ENUM_BUTTON_N,
	BETRAY_ENUM_BUTTON_O,
	BETRAY_ENUM_BUTTON_P,
	BETRAY_ENUM_BUTTON_Q,
	BETRAY_ENUM_BUTTON_R,
	BETRAY_ENUM_BUTTON_S,
	BETRAY_ENUM_BUTTON_T,
	BETRAY_ENUM_BUTTON_U,
	BETRAY_ENUM_BUTTON_V,
	BETRAY_ENUM_BUTTON_W,
	BETRAY_ENUM_BUTTON_X,
	BETRAY_ENUM_BUTTON_Y,
	BETRAY_ENUM_BUTTON_Z,
	BETRAY_ENUM_BUTTON_NUMPAD0,
	BETRAY_ENUM_BUTTON_NUMPAD1,
	BETRAY_ENUM_BUTTON_NUMPAD2,
	BETRAY_ENUM_BUTTON_NUMPAD3,
	BETRAY_ENUM_BUTTON_NUMPAD4,
	BETRAY_ENUM_BUTTON_NUMPAD5,
	BETRAY_ENUM_BUTTON_NUMPAD6,
	BETRAY_ENUM_BUTTON_NUMPAD7,
	BETRAY_ENUM_BUTTON_NUMPAD8,
	BETRAY_ENUM_BUTTON_NUMPAD9,
	BETRAY_ENUM_BUTTON_MULTIPLY,
	BETRAY_ENUM_BUTTON_ADD,
	BETRAY_ENUM_BUTTON_SUBTRACT,
	BETRAY_ENUM_BUTTON_DIVIDE,
	BETRAY_ENUM_BUTTON_F1,
	BETRAY_ENUM_BUTTON_F2,
	BETRAY_ENUM_BUTTON_F3,
	BETRAY_ENUM_BUTTON_F4,
	BETRAY_ENUM_BUTTON_F5,
	BETRAY_ENUM_BUTTON_F6,
	BETRAY_ENUM_BUTTON_F7,
	BETRAY_ENUM_BUTTON_F8,
	BETRAY_ENUM_BUTTON_F9,
	BETRAY_ENUM_BUTTON_F10,
	BETRAY_ENUM_BUTTON_F11,
	BETRAY_ENUM_BUTTON_F12,
	BETRAY_ENUM_BUTTON_F13,
	BETRAY_ENUM_BUTTON_F14,
	BETRAY_ENUM_BUTTON_F15,
	BETRAY_ENUM_BUTTON_F16,
	BETRAY_ENUM_BUTTON_F17,
	BETRAY_ENUM_BUTTON_F18,
	BETRAY_ENUM_BUTTON_F19,
	BETRAY_ENUM_BUTTON_F20,
	BETRAY_ENUM_BUTTON_F21,
	BETRAY_ENUM_BUTTON_F22,
	BETRAY_ENUM_BUTTON_F23,
	BETRAY_ENUM_BUTTON_F24,
	BETRAY_ENUM_BUTTON_VOLUME_DOWN,
	BETRAY_ENUM_BUTTON_VOLUME_UP,
	BETRAY_ENUM_BUTTON_NEXT_TRACK,
	BETRAY_ENUM_BUTTON_PREV_TRACK,
	BETRAY_ENUM_BUTTON_STOP,
	BETRAY_ENUM_BUTTON_PLAY_PAUSE,
	BETRAY_ENUM_BUTTON_FACE_A,
	BETRAY_ENUM_BUTTON_FACE_B,
	BETRAY_ENUM_BUTTON_FACE_C,
	BETRAY_ENUM_BUTTON_FACE_D,
	BETRAY_ENUM_BUTTON_FACE_X,
	BETRAY_ENUM_BUTTON_FACE_Y,
	BETRAY_ENUM_BUTTON_FACE_Z,
	BETRAY_ENUM_BUTTON_FACE_W,
	BETRAY_ENUM_BUTTON_YES,
	BETRAY_ENUM_BUTTON_NO,
	BETRAY_ENUM_BUTTON_UNDO,
	BETRAY_ENUM_BUTTON_REDO,
	BETRAY_ENUM_BUTTON_CUT,
	BETRAY_ENUM_BUTTON_COPY,
	BETRAY_ENUM_BUTTON_PASTE,
	BETRAY_ENUM_BUTTON_SEARCH,
	BETRAY_ENUM_BUTTON_SHOLDER_LEFT_A,
	BETRAY_ENUM_BUTTON_SHOLDER_LEFT_B,
	BETRAY_ENUM_BUTTON_SHOLDER_LEFT_C,
	BETRAY_ENUM_BUTTON_SHOLDER_LEFT_D,
	BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_A,
	BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_B,
	BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_C,
	BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_D,
	BETRAY_ENUM_BUTTON_SCROLL_UP,
	BETRAY_ENUM_BUTTON_SCROLL_DOWN,
	BETRAY_ENUM_BUTTON_SCROLL_LEFT,
	BETRAY_ENUM_BUTTON_SCROLL_RIGHT,
	BETRAY_ENUM_BUTTON_INVENTORY_NEXT,
	BETRAY_ENUM_BUTTON_INVENTORY_PREVIOUS,
	BETRAY_ENUM_BUTTON_KEY_END,
	BETRAY_ENUM_BUTTON_COUNT = BETRAY_ENUM_BUTTON_KEY_END + 256
}BetrayButtonInternal;

#ifdef BETRAY_PLUGGIN_KEYS

#define BETRAY_BUTTON_CANCEL		BETRAY_ENUM_BUTTON_CANCEL
#define BETRAY_BUTTON_BACK			BETRAY_ENUM_BUTTON_BACK
#define BETRAY_BUTTON_TAB			BETRAY_ENUM_BUTTON_TAB
#define BETRAY_BUTTON_CLEAR			BETRAY_ENUM_BUTTON_CLEAR
#define BETRAY_BUTTON_RETURN		BETRAY_ENUM_BUTTON_RETURN
#define BETRAY_BUTTON_SHIFT			BETRAY_ENUM_BUTTON_SHIFT
#define BETRAY_BUTTON_CONTROL		BETRAY_ENUM_BUTTON_CONTROL
#define BETRAY_BUTTON_MENU			BETRAY_ENUM_BUTTON_MENU
#define BETRAY_BUTTON_PAUSE			BETRAY_ENUM_BUTTON_PAUSE
#define BETRAY_BUTTON_CAPS_LOCK		BETRAY_ENUM_BUTTON_CAPS_LOCK
#define BETRAY_BUTTON_ESCAPE		BETRAY_ENUM_BUTTON_ESCAPE
#define BETRAY_BUTTON_SPACE			BETRAY_ENUM_BUTTON_SPACE
#define BETRAY_BUTTON_PREV			BETRAY_ENUM_BUTTON_PREV
#define BETRAY_BUTTON_NEXT			BETRAY_ENUM_BUTTON_NEXT
#define BETRAY_BUTTON_END			BETRAY_ENUM_BUTTON_END
#define BETRAY_BUTTON_HOME			BETRAY_ENUM_BUTTON_HOME
#define BETRAY_BUTTON_LEFT			BETRAY_ENUM_BUTTON_LEFT
#define BETRAY_BUTTON_UP			BETRAY_ENUM_BUTTON_UP
#define BETRAY_BUTTON_RIGHT			BETRAY_ENUM_BUTTON_RIGHT
#define BETRAY_BUTTON_DOWN			BETRAY_ENUM_BUTTON_DOWN
#define BETRAY_BUTTON_SELECT		BETRAY_ENUM_BUTTON_SELECT
#define BETRAY_BUTTON_PRINT			BETRAY_ENUM_BUTTON_PRINT
#define BETRAY_BUTTON_EXECUTE		BETRAY_ENUM_BUTTON_EXECUTE
#define BETRAY_BUTTON_SCREESHOT		BETRAY_ENUM_BUTTON_SCREENSHOT
#define BETRAY_BUTTON_INSERT		BETRAY_ENUM_BUTTON_INSERT
#define BETRAY_BUTTON_DELETE		BETRAY_ENUM_BUTTON_DELETE
#define BETRAY_BUTTON_BACKSPACE		BETRAY_ENUM_BUTTON_BACKSPACE
#define BETRAY_BUTTON_HELP			BETRAY_ENUM_BUTTON_HELP
#define BETRAY_BUTTON_0				BETRAY_ENUM_BUTTON_0
#define BETRAY_BUTTON_1				BETRAY_ENUM_BUTTON_1
#define BETRAY_BUTTON_2				BETRAY_ENUM_BUTTON_2
#define BETRAY_BUTTON_3				BETRAY_ENUM_BUTTON_3
#define BETRAY_BUTTON_4				BETRAY_ENUM_BUTTON_4
#define BETRAY_BUTTON_5				BETRAY_ENUM_BUTTON_5
#define BETRAY_BUTTON_6				BETRAY_ENUM_BUTTON_6
#define BETRAY_BUTTON_7				BETRAY_ENUM_BUTTON_7
#define BETRAY_BUTTON_8				BETRAY_ENUM_BUTTON_8
#define BETRAY_BUTTON_9				BETRAY_ENUM_BUTTON_9
#define BETRAY_BUTTON_A				BETRAY_ENUM_BUTTON_A
#define BETRAY_BUTTON_B				BETRAY_ENUM_BUTTON_B
#define BETRAY_BUTTON_C				BETRAY_ENUM_BUTTON_C
#define BETRAY_BUTTON_D				BETRAY_ENUM_BUTTON_D
#define BETRAY_BUTTON_E				BETRAY_ENUM_BUTTON_E
#define BETRAY_BUTTON_F				BETRAY_ENUM_BUTTON_F
#define BETRAY_BUTTON_G				BETRAY_ENUM_BUTTON_G
#define BETRAY_BUTTON_H				BETRAY_ENUM_BUTTON_H
#define BETRAY_BUTTON_I				BETRAY_ENUM_BUTTON_I
#define BETRAY_BUTTON_J				BETRAY_ENUM_BUTTON_J
#define BETRAY_BUTTON_K				BETRAY_ENUM_BUTTON_K
#define BETRAY_BUTTON_L				BETRAY_ENUM_BUTTON_L
#define BETRAY_BUTTON_M				BETRAY_ENUM_BUTTON_M
#define BETRAY_BUTTON_N				BETRAY_ENUM_BUTTON_N
#define BETRAY_BUTTON_O				BETRAY_ENUM_BUTTON_O
#define BETRAY_BUTTON_P				BETRAY_ENUM_BUTTON_P
#define BETRAY_BUTTON_Q				BETRAY_ENUM_BUTTON_Q
#define BETRAY_BUTTON_R				BETRAY_ENUM_BUTTON_R
#define BETRAY_BUTTON_S				BETRAY_ENUM_BUTTON_S
#define BETRAY_BUTTON_T				BETRAY_ENUM_BUTTON_T
#define BETRAY_BUTTON_U				BETRAY_ENUM_BUTTON_U
#define BETRAY_BUTTON_V				BETRAY_ENUM_BUTTON_V
#define BETRAY_BUTTON_W				BETRAY_ENUM_BUTTON_W
#define BETRAY_BUTTON_X				BETRAY_ENUM_BUTTON_X
#define BETRAY_BUTTON_Y				BETRAY_ENUM_BUTTON_Y
#define BETRAY_BUTTON_Z				BETRAY_ENUM_BUTTON_Z
#define BETRAY_BUTTON_NUM_0			BETRAY_ENUM_BUTTON_NUM_0
#define BETRAY_BUTTON_NUM_1			BETRAY_ENUM_BUTTON_NUM_1
#define BETRAY_BUTTON_NUM_2			BETRAY_ENUM_BUTTON_NUM_2
#define BETRAY_BUTTON_NUM_3			BETRAY_ENUM_BUTTON_NUM_3
#define BETRAY_BUTTON_NUM_4			BETRAY_ENUM_BUTTON_NUM_4
#define BETRAY_BUTTON_NUM_5			BETRAY_ENUM_BUTTON_NUM_5
#define BETRAY_BUTTON_NUM_6			BETRAY_ENUM_BUTTON_NUM_6
#define BETRAY_BUTTON_NUM_7			BETRAY_ENUM_BUTTON_NUM_7
#define BETRAY_BUTTON_NUM_8			BETRAY_ENUM_BUTTON_NUM_8
#define BETRAY_BUTTON_NUM_9			BETRAY_ENUM_BUTTON_NUM_9
#define BETRAY_BUTTON_MULTIPLY		BETRAY_ENUM_BUTTON_MULTIPLY
#define BETRAY_BUTTON_ADD			BETRAY_ENUM_BUTTON_ADD
#define BETRAY_BUTTON_SUBTRACT		BETRAY_ENUM_BUTTON_SUBTRACT
#define BETRAY_BUTTON_DIVIDE		BETRAY_ENUM_BUTTON_DIVIDE
#define BETRAY_BUTTON_F1			BETRAY_ENUM_BUTTON_F1
#define BETRAY_BUTTON_F2			BETRAY_ENUM_BUTTON_F2
#define BETRAY_BUTTON_F3			BETRAY_ENUM_BUTTON_F3
#define BETRAY_BUTTON_F4			BETRAY_ENUM_BUTTON_F4
#define BETRAY_BUTTON_F5			BETRAY_ENUM_BUTTON_F5
#define BETRAY_BUTTON_F6			BETRAY_ENUM_BUTTON_F6
#define BETRAY_BUTTON_F7			BETRAY_ENUM_BUTTON_F7
#define BETRAY_BUTTON_F8			BETRAY_ENUM_BUTTON_F8
#define BETRAY_BUTTON_F9			BETRAY_ENUM_BUTTON_F9
#define BETRAY_BUTTON_F10			BETRAY_ENUM_BUTTON_F10
#define BETRAY_BUTTON_F11			BETRAY_ENUM_BUTTON_F11
#define BETRAY_BUTTON_F12			BETRAY_ENUM_BUTTON_F12
#define BETRAY_BUTTON_F13			BETRAY_ENUM_BUTTON_F13
#define BETRAY_BUTTON_F14			BETRAY_ENUM_BUTTON_F14
#define BETRAY_BUTTON_F15			BETRAY_ENUM_BUTTON_F15
#define BETRAY_BUTTON_F16			BETRAY_ENUM_BUTTON_F16
#define BETRAY_BUTTON_F17			BETRAY_ENUM_BUTTON_F17
#define BETRAY_BUTTON_F18			BETRAY_ENUM_BUTTON_F18
#define BETRAY_BUTTON_F19			BETRAY_ENUM_BUTTON_F19
#define BETRAY_BUTTON_F20			BETRAY_ENUM_BUTTON_F20
#define BETRAY_BUTTON_F21			BETRAY_ENUM_BUTTON_F21
#define BETRAY_BUTTON_F22			BETRAY_ENUM_BUTTON_F22
#define BETRAY_BUTTON_F23			BETRAY_ENUM_BUTTON_F23
#define BETRAY_BUTTON_F24			BETRAY_ENUM_BUTTON_F24
#define BETRAY_BUTTON_VOLUME_DOWN	BETRAY_ENUM_BUTTON_VOLUME_DOWN
#define BETRAY_BUTTON_VOLUME_UP		BETRAY_ENUM_BUTTON_VOLUME_UP
#define BETRAY_BUTTON_NEXT_TRACK	BETRAY_ENUM_BUTTON_NEXT_TRACK
#define BETRAY_BUTTON_PREVIOUS_TRACK BETRAY_ENUM_BUTTON_PREV_TRACK
#define BETRAY_BUTTON_STOP			BETRAY_ENUM_BUTTON_STOP
#define BETRAY_BUTTON_PLAY_PAUSE	BETRAY_ENUM_BUTTON_PLAY_PAUSE
#define BETRAY_BUTTON_FACE_A		BETRAY_ENUM_BUTTON_FACE_A
#define BETRAY_BUTTON_FACE_B		BETRAY_ENUM_BUTTON_FACE_B
#define BETRAY_BUTTON_FACE_C		BETRAY_ENUM_BUTTON_FACE_C
#define BETRAY_BUTTON_FACE_D		BETRAY_ENUM_BUTTON_FACE_D
#define BETRAY_BUTTON_FACE_X		BETRAY_ENUM_BUTTON_FACE_X
#define BETRAY_BUTTON_FACE_Y		BETRAY_ENUM_BUTTON_FACE_Y
#define BETRAY_BUTTON_FACE_Z		BETRAY_ENUM_BUTTON_FACE_Z
#define BETRAY_BUTTON_FACE_W		BETRAY_ENUM_BUTTON_FACE_W
#define BETRAY_BUTTON_YES			BETRAY_ENUM_BUTTON_YES
#define BETRAY_BUTTON_NO			BETRAY_ENUM_BUTTON_NO
#define BETRAY_BUTTON_UNDO			BETRAY_ENUM_BUTTON_UNDO
#define BETRAY_BUTTON_REDO			BETRAY_ENUM_BUTTON_REDO
#define BETRAY_BUTTON_CUT			BETRAY_ENUM_BUTTON_CUT
#define BETRAY_BUTTON_COPY			BETRAY_ENUM_BUTTON_COPY
#define BETRAY_BUTTON_PASTE			BETRAY_ENUM_BUTTON_PASTE
#define BETRAY_BUTTON_SEARCH		BETRAY_ENUM_BUTTON_SEARCH
#define BETRAY_BUTTON_SHOLDER_LEFT_A BETRAY_ENUM_BUTTON_SHOLDER_LEFT_A
#define BETRAY_BUTTON_SHOLDER_LEFT_B BETRAY_ENUM_BUTTON_SHOLDER_LEFT_B
#define BETRAY_BUTTON_SHOLDER_LEFT_C BETRAY_ENUM_BUTTON_SHOLDER_LEFT_C
#define BETRAY_BUTTON_SHOLDER_LEFT_D BETRAY_ENUM_BUTTON_SHOLDER_LEFT_D
#define BETRAY_BUTTON_SHOLDER_RIGHT_A BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_A
#define BETRAY_BUTTON_SHOLDER_RIGHT_B BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_B
#define BETRAY_BUTTON_SHOLDER_RIGHT_C BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_C
#define BETRAY_BUTTON_SHOLDER_RIGHT_D BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_D
#define BETRAY_BUTTON_SCROLL_UP		BETRAY_ENUM_BUTTON_SCROLL_UP
#define BETRAY_BUTTON_SCROLL_DOWN	BETRAY_ENUM_BUTTON_SCROLL_DOWN
#define BETRAY_BUTTON_SCROLL_LEFT	BETRAY_ENUM_BUTTON_SCROLL_LEFT
#define BETRAY_BUTTON_SCROLL_RIGHT	BETRAY_ENUM_BUTTON_SCROLL_RIGHT
#define BETRAY_BUTTON_INVENTORY_NEXT BETRAY_ENUM_BUTTON_INVENTORY_NEXT
#define BETRAY_BUTTON_INVENTORY_PREVIOUS BETRAY_ENUM_BUTTON_INVENTORY_PREVIOUS

#else

#define BETRAY_BUTTON_CANCEL		betray_buttons[BETRAY_ENUM_BUTTON_CANCEL].system_code
#define BETRAY_BUTTON_BACK			betray_buttons[BETRAY_ENUM_BUTTON_BACK].system_code
#define BETRAY_BUTTON_TAB			betray_buttons[BETRAY_ENUM_BUTTON_TAB].system_code
#define BETRAY_BUTTON_CLEAR			betray_buttons[BETRAY_ENUM_BUTTON_CLEAR].system_code
#define BETRAY_BUTTON_RETURN		betray_buttons[BETRAY_ENUM_BUTTON_RETURN].system_code
#define BETRAY_BUTTON_SHIFT			betray_buttons[BETRAY_ENUM_BUTTON_SHIFT].system_code
#define BETRAY_BUTTON_CONTROL		betray_buttons[BETRAY_ENUM_BUTTON_CONTROL].system_code
#define BETRAY_BUTTON_MENU			betray_buttons[BETRAY_ENUM_BUTTON_MENU].system_code
#define BETRAY_BUTTON_PAUSE			betray_buttons[BETRAY_ENUM_BUTTON_PAUSE].system_code
#define BETRAY_BUTTON_CAPS_LOCK		betray_buttons[BETRAY_ENUM_BUTTON_CAPS_LOCK].system_code
#define BETRAY_BUTTON_ESCAPE		betray_buttons[BETRAY_ENUM_BUTTON_ESCAPE].system_code
#define BETRAY_BUTTON_SPACE			betray_buttons[BETRAY_ENUM_BUTTON_SPACE].system_code
#define BETRAY_BUTTON_PREV			betray_buttons[BETRAY_ENUM_BUTTON_PREV].system_code
#define BETRAY_BUTTON_NEXT			betray_buttons[BETRAY_ENUM_BUTTON_NEXT].system_code
#define BETRAY_BUTTON_END			betray_buttons[BETRAY_ENUM_BUTTON_END].system_code
#define BETRAY_BUTTON_HOME			betray_buttons[BETRAY_ENUM_BUTTON_HOME].system_code
#define BETRAY_BUTTON_LEFT			betray_buttons[BETRAY_ENUM_BUTTON_LEFT].system_code
#define BETRAY_BUTTON_UP			betray_buttons[BETRAY_ENUM_BUTTON_UP].system_code
#define BETRAY_BUTTON_RIGHT			betray_buttons[BETRAY_ENUM_BUTTON_RIGHT].system_code
#define BETRAY_BUTTON_DOWN			betray_buttons[BETRAY_ENUM_BUTTON_DOWN].system_code
#define BETRAY_BUTTON_SELECT		betray_buttons[BETRAY_ENUM_BUTTON_SELECT].system_code
#define BETRAY_BUTTON_PRINT			betray_buttons[BETRAY_ENUM_BUTTON_PRINT].system_code
#define BETRAY_BUTTON_EXECUTE		betray_buttons[BETRAY_ENUM_BUTTON_EXECUTE].system_code
#define BETRAY_BUTTON_SCREESHOT		betray_buttons[BETRAY_ENUM_BUTTON_SCREENSHOT].system_code
#define BETRAY_BUTTON_INSERT		betray_buttons[BETRAY_ENUM_BUTTON_INSERT].system_code
#define BETRAY_BUTTON_DELETE		betray_buttons[BETRAY_ENUM_BUTTON_DELETE].system_code
#define BETRAY_BUTTON_BACKSPACE		betray_buttons[BETRAY_ENUM_BUTTON_BACKSPACE].system_code
#define BETRAY_BUTTON_HELP			betray_buttons[BETRAY_ENUM_BUTTON_HELP].system_code
#define BETRAY_BUTTON_0				betray_buttons[BETRAY_ENUM_BUTTON_0].system_code
#define BETRAY_BUTTON_1				betray_buttons[BETRAY_ENUM_BUTTON_1].system_code
#define BETRAY_BUTTON_2				betray_buttons[BETRAY_ENUM_BUTTON_2].system_code
#define BETRAY_BUTTON_3				betray_buttons[BETRAY_ENUM_BUTTON_3].system_code
#define BETRAY_BUTTON_4				betray_buttons[BETRAY_ENUM_BUTTON_4].system_code
#define BETRAY_BUTTON_5				betray_buttons[BETRAY_ENUM_BUTTON_5].system_code
#define BETRAY_BUTTON_6				betray_buttons[BETRAY_ENUM_BUTTON_6].system_code
#define BETRAY_BUTTON_7				betray_buttons[BETRAY_ENUM_BUTTON_7].system_code
#define BETRAY_BUTTON_8				betray_buttons[BETRAY_ENUM_BUTTON_8].system_code
#define BETRAY_BUTTON_9				betray_buttons[BETRAY_ENUM_BUTTON_9].system_code
#define BETRAY_BUTTON_A				betray_buttons[BETRAY_ENUM_BUTTON_A].system_code
#define BETRAY_BUTTON_B				betray_buttons[BETRAY_ENUM_BUTTON_B].system_code
#define BETRAY_BUTTON_C				betray_buttons[BETRAY_ENUM_BUTTON_C].system_code
#define BETRAY_BUTTON_D				betray_buttons[BETRAY_ENUM_BUTTON_D].system_code
#define BETRAY_BUTTON_E				betray_buttons[BETRAY_ENUM_BUTTON_E].system_code
#define BETRAY_BUTTON_F				betray_buttons[BETRAY_ENUM_BUTTON_F].system_code
#define BETRAY_BUTTON_G				betray_buttons[BETRAY_ENUM_BUTTON_G].system_code
#define BETRAY_BUTTON_H				betray_buttons[BETRAY_ENUM_BUTTON_H].system_code
#define BETRAY_BUTTON_I				betray_buttons[BETRAY_ENUM_BUTTON_I].system_code
#define BETRAY_BUTTON_J				betray_buttons[BETRAY_ENUM_BUTTON_J].system_code
#define BETRAY_BUTTON_K				betray_buttons[BETRAY_ENUM_BUTTON_K].system_code
#define BETRAY_BUTTON_L				betray_buttons[BETRAY_ENUM_BUTTON_L].system_code
#define BETRAY_BUTTON_M				betray_buttons[BETRAY_ENUM_BUTTON_M].system_code
#define BETRAY_BUTTON_N				betray_buttons[BETRAY_ENUM_BUTTON_N].system_code
#define BETRAY_BUTTON_O				betray_buttons[BETRAY_ENUM_BUTTON_O].system_code
#define BETRAY_BUTTON_P				betray_buttons[BETRAY_ENUM_BUTTON_P].system_code
#define BETRAY_BUTTON_Q				betray_buttons[BETRAY_ENUM_BUTTON_Q].system_code
#define BETRAY_BUTTON_R				betray_buttons[BETRAY_ENUM_BUTTON_R].system_code
#define BETRAY_BUTTON_S				betray_buttons[BETRAY_ENUM_BUTTON_S].system_code
#define BETRAY_BUTTON_T				betray_buttons[BETRAY_ENUM_BUTTON_T].system_code
#define BETRAY_BUTTON_U				betray_buttons[BETRAY_ENUM_BUTTON_U].system_code
#define BETRAY_BUTTON_V				betray_buttons[BETRAY_ENUM_BUTTON_V].system_code
#define BETRAY_BUTTON_W				betray_buttons[BETRAY_ENUM_BUTTON_W].system_code
#define BETRAY_BUTTON_X				betray_buttons[BETRAY_ENUM_BUTTON_X].system_code
#define BETRAY_BUTTON_Y				betray_buttons[BETRAY_ENUM_BUTTON_Y].system_code
#define BETRAY_BUTTON_Z				betray_buttons[BETRAY_ENUM_BUTTON_Z].system_code
#define BETRAY_BUTTON_NUM_0			betray_buttons[BETRAY_ENUM_BUTTON_NUM_0].system_code
#define BETRAY_BUTTON_NUM_1			betray_buttons[BETRAY_ENUM_BUTTON_NUM_1].system_code
#define BETRAY_BUTTON_NUM_2			betray_buttons[BETRAY_ENUM_BUTTON_NUM_2].system_code
#define BETRAY_BUTTON_NUM_3			betray_buttons[BETRAY_ENUM_BUTTON_NUM_3].system_code
#define BETRAY_BUTTON_NUM_4			betray_buttons[BETRAY_ENUM_BUTTON_NUM_4].system_code
#define BETRAY_BUTTON_NUM_5			betray_buttons[BETRAY_ENUM_BUTTON_NUM_5].system_code
#define BETRAY_BUTTON_NUM_6			betray_buttons[BETRAY_ENUM_BUTTON_NUM_6].system_code
#define BETRAY_BUTTON_NUM_7			betray_buttons[BETRAY_ENUM_BUTTON_NUM_7].system_code
#define BETRAY_BUTTON_NUM_8			betray_buttons[BETRAY_ENUM_BUTTON_NUM_8].system_code
#define BETRAY_BUTTON_NUM_9			betray_buttons[BETRAY_ENUM_BUTTON_NUM_9].system_code
#define BETRAY_BUTTON_MULTIPLY		betray_buttons[BETRAY_ENUM_BUTTON_MULTIPLY].system_code
#define BETRAY_BUTTON_ADD			betray_buttons[BETRAY_ENUM_BUTTON_ADD].system_code
#define BETRAY_BUTTON_SUBTRACT		betray_buttons[BETRAY_ENUM_BUTTON_SUBTRACT].system_code
#define BETRAY_BUTTON_DIVIDE		betray_buttons[BETRAY_ENUM_BUTTON_DIVIDE].system_code
#define BETRAY_BUTTON_F1			betray_buttons[BETRAY_ENUM_BUTTON_F1].system_code
#define BETRAY_BUTTON_F2			betray_buttons[BETRAY_ENUM_BUTTON_F2].system_code
#define BETRAY_BUTTON_F3			betray_buttons[BETRAY_ENUM_BUTTON_F3].system_code
#define BETRAY_BUTTON_F4			betray_buttons[BETRAY_ENUM_BUTTON_F4].system_code
#define BETRAY_BUTTON_F5			betray_buttons[BETRAY_ENUM_BUTTON_F5].system_code
#define BETRAY_BUTTON_F6			betray_buttons[BETRAY_ENUM_BUTTON_F6].system_code
#define BETRAY_BUTTON_F7			betray_buttons[BETRAY_ENUM_BUTTON_F7].system_code
#define BETRAY_BUTTON_F8			betray_buttons[BETRAY_ENUM_BUTTON_F8].system_code
#define BETRAY_BUTTON_F9			betray_buttons[BETRAY_ENUM_BUTTON_F9].system_code
#define BETRAY_BUTTON_F10			betray_buttons[BETRAY_ENUM_BUTTON_F10].system_code
#define BETRAY_BUTTON_F11			betray_buttons[BETRAY_ENUM_BUTTON_F11].system_code
#define BETRAY_BUTTON_F12			betray_buttons[BETRAY_ENUM_BUTTON_F12].system_code
#define BETRAY_BUTTON_F13			betray_buttons[BETRAY_ENUM_BUTTON_F13].system_code
#define BETRAY_BUTTON_F14			betray_buttons[BETRAY_ENUM_BUTTON_F14].system_code
#define BETRAY_BUTTON_F15			betray_buttons[BETRAY_ENUM_BUTTON_F15].system_code
#define BETRAY_BUTTON_F16			betray_buttons[BETRAY_ENUM_BUTTON_F16].system_code
#define BETRAY_BUTTON_F17			betray_buttons[BETRAY_ENUM_BUTTON_F17].system_code
#define BETRAY_BUTTON_F18			betray_buttons[BETRAY_ENUM_BUTTON_F18].system_code
#define BETRAY_BUTTON_F19			betray_buttons[BETRAY_ENUM_BUTTON_F19].system_code
#define BETRAY_BUTTON_F20			betray_buttons[BETRAY_ENUM_BUTTON_F20].system_code
#define BETRAY_BUTTON_F21			betray_buttons[BETRAY_ENUM_BUTTON_F21].system_code
#define BETRAY_BUTTON_F22			betray_buttons[BETRAY_ENUM_BUTTON_F22].system_code
#define BETRAY_BUTTON_F23			betray_buttons[BETRAY_ENUM_BUTTON_F23].system_code
#define BETRAY_BUTTON_F24			betray_buttons[BETRAY_ENUM_BUTTON_F24].system_code
#define BETRAY_BUTTON_VOLUME_DOWN	betray_buttons[BETRAY_ENUM_BUTTON_VOLUME_DOWN].system_code
#define BETRAY_BUTTON_VOLUME_UP		betray_buttons[BETRAY_ENUM_BUTTON_VOLUME_UP].system_code
#define BETRAY_BUTTON_NEXT_TRACK	betray_buttons[BETRAY_ENUM_BUTTON_NEXT_TRACK].system_code
#define BETRAY_BUTTON_PREVIOUS_TRACK betray_buttons[BETRAY_ENUM_BUTTON_PREV_TRACK].system_code
#define BETRAY_BUTTON_STOP			betray_buttons[BETRAY_ENUM_BUTTON_STOP].system_code
#define BETRAY_BUTTON_PLAY_PAUSE	betray_buttons[BETRAY_ENUM_BUTTON_PLAY_PAUSE].system_code
#define BETRAY_BUTTON_FACE_A		betray_buttons[BETRAY_ENUM_BUTTON_FACE_A].system_code
#define BETRAY_BUTTON_FACE_B		betray_buttons[BETRAY_ENUM_BUTTON_FACE_B].system_code
#define BETRAY_BUTTON_FACE_C		betray_buttons[BETRAY_ENUM_BUTTON_FACE_C].system_code
#define BETRAY_BUTTON_FACE_D		betray_buttons[BETRAY_ENUM_BUTTON_FACE_D].system_code
#define BETRAY_BUTTON_FACE_X		betray_buttons[BETRAY_ENUM_BUTTON_FACE_X].system_code
#define BETRAY_BUTTON_FACE_Y		betray_buttons[BETRAY_ENUM_BUTTON_FACE_Y].system_code
#define BETRAY_BUTTON_FACE_Z		betray_buttons[BETRAY_ENUM_BUTTON_FACE_Z].system_code
#define BETRAY_BUTTON_FACE_W		betray_buttons[BETRAY_ENUM_BUTTON_FACE_W].system_code
#define BETRAY_BUTTON_YES			betray_buttons[BETRAY_ENUM_BUTTON_YES].system_code
#define BETRAY_BUTTON_NO			betray_buttons[BETRAY_ENUM_BUTTON_NO].system_code
#define BETRAY_BUTTON_UNDO			betray_buttons[BETRAY_ENUM_BUTTON_UNDO].system_code
#define BETRAY_BUTTON_REDO			betray_buttons[BETRAY_ENUM_BUTTON_REDO].system_code
#define BETRAY_BUTTON_CUT			betray_buttons[BETRAY_ENUM_BUTTON_CUT].system_code
#define BETRAY_BUTTON_COPY			betray_buttons[BETRAY_ENUM_BUTTON_COPY].system_code
#define BETRAY_BUTTON_PASTE			betray_buttons[BETRAY_ENUM_BUTTON_PASTE].system_code
#define BETRAY_BUTTON_SEARCH		betray_buttons[BETRAY_ENUM_BUTTON_SEARCH].system_code
#define BETRAY_BUTTON_SHOLDER_LEFT_A betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_LEFT_A].system_code
#define BETRAY_BUTTON_SHOLDER_LEFT_B betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_LEFT_B].system_code
#define BETRAY_BUTTON_SHOLDER_LEFT_C betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_LEFT_C].system_code
#define BETRAY_BUTTON_SHOLDER_LEFT_D betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_LEFT_D].system_code
#define BETRAY_BUTTON_SHOLDER_RIGHT_A betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_A].system_code
#define BETRAY_BUTTON_SHOLDER_RIGHT_B betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_B].system_code
#define BETRAY_BUTTON_SHOLDER_RIGHT_C betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_C].system_code
#define BETRAY_BUTTON_SHOLDER_RIGHT_D betray_buttons[BETRAY_ENUM_BUTTON_SHOLDER_RIGHT_D].system_code
#define BETRAY_BUTTON_SCROLL_UP		betray_buttons[BETRAY_ENUM_BUTTON_SCROLL_UP].system_code
#define BETRAY_BUTTON_SCROLL_DOWN	betray_buttons[BETRAY_ENUM_BUTTON_SCROLL_DOWN].system_code
#define BETRAY_BUTTON_SCROLL_LEFT	betray_buttons[BETRAY_ENUM_BUTTON_SCROLL_LEFT].system_code
#define BETRAY_BUTTON_SCROLL_RIGHT	betray_buttons[BETRAY_ENUM_BUTTON_SCROLL_RIGHT].system_code
#define BETRAY_BUTTON_INVENTORY_NEXT betray_buttons[BETRAY_ENUM_BUTTON_INVENTORY_NEXT].system_code
#define BETRAY_BUTTON_INVENTORY_PREVIOUS betray_buttons[BETRAY_ENUM_BUTTON_INVENTORY_PREVIOUS].system_code

#endif 


